/*******************************************************************************
* Copyright 2012

* FG Language Technologie
* Technische Universitaet Darmstadt
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
******************************************************************************/
package org.jobimtext.api.struct;

import java.util.List;

import org.apache.pig.impl.util.Pair;
import org.jobimtext.api.IThesaurus;

/**
 * The WebThesaurusInterface extends the IThesaurus interface. It offers one additional method, getSentenceHoling(String sentence)
 * @author Eugen Ruppert
 *
 * @param <KEY> The structure used for a term representation
 * @param <VALUES> The structure used for context representation
 */

public interface WebThesaurusInterface <KEY, VALUES> extends IThesaurus<KEY, VALUES, List<Order2>, List<Order1>, List<Sense>, List<Sense>, List<Sense>>{
	
	/**
	 * Performs the holing operation of the currently specified resource
	 * @param sentence The input sentence
	 * @return a list of term and feature-list pairs
	 */
	public List<Pair<String, List<String>>> getSentenceHoling(String sentence);

}
