package org.jobimtext.holing.annotator;

import java.util.LinkedList;
import java.util.List;

import org.apache.uima.fit.descriptor.ConfigurationParameter;
import org.apache.uima.jcas.tcas.Annotation;
import org.jobimtext.holing.type.Token;

public class JoPosAnnotator extends JoAnnotator {

	public static final String PARAM_POS_PATTERN = "PosPattern";
	@ConfigurationParameter(name = PARAM_POS_PATTERN)
	private String posStr = "N.*";

	@Override
	public List<Annotation> addToken(LinkedList<Annotation> list, Annotation t) {
		String pos = getPos(t);
		if (pos != null && pos.matches(posStr)) {
			list.add(t);
		} else {
			list.clear();
		}
		return list;
	}

	private String getPos(Annotation t) {
		if (t.getClass().toString().compareTo(tokenAnnotation.toString()) == 0) {
			try {
				return ((Token) t).getPOS().getPosValue();
			} catch (Exception e) {
				return null;
			}
		} else {
			throw new IllegalArgumentException("The Annotation is not of type "
					+ tokenAnnotation + " but " + t.getClass().getName());
		}
	}

}
