package org.jobimtext.holing.segmenter;

import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.jcas.JCas;
import org.jobimtext.holing.type.Sentence;


/**
 * @author eruppert
 *
 */
public class SentencePerLineAnnotator extends JCasAnnotator_ImplBase {



	public void process(JCas aJCas) {
		String aText = aJCas.getDocumentText();
		int length = aText.length();
		int offset = 0;		
		
		for (int i = 0 ; i< length; i++) {
	        if (aText.charAt(i) == '\n') {
		        createSentence(aJCas, offset, i);
		        offset = i+1;
	        }
		}
		if (offset < length) {
			createSentence(aJCas, offset, length);
		}
	}

	private void createSentence(JCas aJCas, int begin, int end) {
		if (isEmpty(begin, end)) return;
		Sentence sentence = new Sentence(aJCas, begin, end);
		sentence.addToIndexes();
	}

	public boolean isEmpty(int aBegin, int aEnd) {
		return aBegin >= aEnd;
	}

}
