package org.jobimtext.util;

import java.util.ArrayList;
import java.util.Arrays;

public class StringUtils {
/**
 * splits the seq according to the delimiter and does not return empty fields
 * @param seq
 * @param delimiter
 * @return
 */
		
	public static String[] splitWithoutEmptyElements(String seq, char delimiter){
		if(seq==null)return null;
		if(seq.length()==0)
			return new String[]{};
		ArrayList<String> elements = new ArrayList<String>();
		int i=0;
		int j =-1;
		
		while((j=seq.indexOf(delimiter, i))!=-1){
			if(i!=j){
				elements.add(seq.substring(i,j));
			}
			i = j+1;
		}
		if(i<seq.length()){
			elements.add(seq.substring(i));
		}
		
		return elements.toArray(new String[elements.size()]);
		
	}
	public static String trim(String word){
		return word.replace((char)65533, ' ').trim().replaceAll("^[\\s\\xA0]+", "").replaceAll("[\\s\\xA0]+$", "");
	}
	
	
	public static String join(String[] input, String delimiter) {
		return join(input,delimiter,0,input.length);		
	}
	public static String join(String[] input, String delimiter, int start) {
		return join(input,delimiter,start,input.length);		
	}
	public static String join(String[] input, String delimiter, int start,int end) {
		StringBuffer buffer = new StringBuffer();
		for (int i=start;i<end;i++){
			buffer.append(delimiter);
			buffer.append(input[i]);
		}
		buffer.delete(0, delimiter.length());
		return buffer.toString();
	}
	
	public static void main(String[] args) {
		String word =" test ";
		System.out.println("^"+word.trim()+"$");
		word =" test \\xA0";
		
		System.out.println("^"+word.trim()+"$");
		System.out.println(Arrays.toString(splitWithoutEmptyElements(null, '\t')));
		System.out.println(Arrays.toString(splitWithoutEmptyElements("", '\t')));
		System.out.println(Arrays.toString(splitWithoutEmptyElements("	he	likes", '\t')));
		System.out.println(Arrays.toString(splitWithoutEmptyElements("			", '\t')));
		System.out.println(Arrays.toString(splitWithoutEmptyElements("		heas			asd			", '\t')));
		
		System.out.println(join(new String[]{"he","likes","coffee"}," ",1));
		System.out.println(join(new String[]{"","he","likes","coffee"}," ",0));
	}
}
